# -*- coding: cp1252 -*-

import pygame
from pygame.locals import *
from sys import exit
from random import randint,shuffle
import time
from config import *

# Variables

VELOCIDADV = 20
VELOCIDADL = 10
      
nivel = 1
cambio = 0
tm = 59
tmr = 0
contadorlobo = 0
muerto = False

sonidopremio = 'data/sonidos/muu.wav'
sonidovelocidad = 'data/sonidos/speed1.wav'
sonidodamage = 'data/sonidos/hurt.wav'
sonidomuerto = 'data/sonidos/no.wav'
sonidovida = 'data/sonidos/price1.wav'
                
class PPrincipal():
    def __init__(self):
        self.imagenes = [[], [], [], [], []]
        n = 0
        for carpeta in ['right', 'left', 'up', 'down', 'die']:
            for numero in range(1, 5):
                self.imagen = pygame.image.load(PERS_PRINC+carpeta+'/'+str(numero)+'.png')
                self.imagen.set_colorkey((0,0,0))
                self.imagen = pygame.transform.scale(self.imagen, (ANCHO/10, ANCHO/10))
                self.imagen = self.imagen.convert()
                self.imagenes[n].append(self.imagen)
            n += 1
        self.rect = self.imagen.get_rect()
        self.rect = self.rect.inflate(-60,-60)
        self.rect.left = 0
        self.rect.top = ALTO/2
        self.carpeta = 0
        self.velocidad = [VELOCIDADV,0]
        self.num = 2
        self.cambio = 0
    def mover(self, manzana, tm, pantalla, keys, tmr, rayo, vidas,score, muerto, sonido):
        global cambio
        global VELOCIDADV
        count = 22
        if vidas < 1:
            if sonido:
                ch_sonidomuerto = pygame.mixer.Channel(7)
                ch_sonidomuerto.play(pygame.mixer.Sound(sonidomuerto))
            self.carpeta = 4
            muerto = True
            pygame.mixer.stop()
            return tm, tmr, muerto, score
        if keys[K_RIGHT]:
            self.velocidad[0] = VELOCIDADV
            self.velocidad[1] = 0
            self.carpeta = 0
        if keys[K_LEFT]:
            self.velocidad[0] = -VELOCIDADV
            self.velocidad[1] = 0
            self.carpeta = 1
        if keys[K_UP]:
            self.velocidad[0] = 0
            self.velocidad[1] = -VELOCIDADV
            self.carpeta = 2
        if keys[K_DOWN]:
            self.velocidad[0] = 0
            self.velocidad[1] = VELOCIDADV
            self.carpeta = 3
                
        # Detectar Bordes
            
        if self.rect.right >= ANCHO:
            self.velocidad[0] = -VELOCIDADV
            self.velocidad[1] = 0
            self.carpeta = 1
        elif self.rect.left < 0:
            self.velocidad[0] = VELOCIDADV
            self.velocidad[1] = 0
            self.carpeta = 0    
        if self.rect.top < ALTO/4.75:
            self.velocidad[1] = VELOCIDADV
            self.velocidad[0] = 0
            self.carpeta = 3
        elif self.rect.bottom > ALTO+20:
            self.velocidad[1] = -VELOCIDADV
            self.velocidad[0] = 0
            self.carpeta = 2
        
        # Mover Objeto
            
        self.rect.left += self.velocidad[0]
        self.rect.top += self.velocidad[1]
        self.cambio += 1
        self.cambio %= 5
        if self.cambio == 0:
            self.num  += 1
            self.num = self.num % 4
                
        # Detectamos colision con la manzana
               
        if self.rect.colliderect(manzana.rect):
            if sonido:
                ch_sonidopremio = pygame.mixer.Channel(4)
                ch_sonidopremio.play(pygame.mixer.Sound(sonidopremio))
            tm = 59
            score += 1
        if self.rect.colliderect(rayo.rect):
            if sonido:
                ch_sonidovelocidad = pygame.mixer.Channel(5)
                ch_sonidovelocidad.play(pygame.mixer.Sound(sonidovelocidad))
            tmr = 99
            self.velocidad[0] *= 1.5
            self.velocidad[1] *= 1.5
            count = 0
        if count == 50:
            self.velocidad[0] /= 1.5
            self.velocidad[1] /= 1.5
        count += 1


        return  tm, tmr, muerto, score
    def dibujar(self, pantalla):         
        pantalla.blit(self.imagenes[self.carpeta][self.num], self.rect)
    def colision(self, obj2):
        try:
            # Creamos los atributos
            rect1, mask1, blank1 = self.rect, self.hitmask, self.blank
            rect2, mask2, blank2 = obj2.rect, obj2.hitmask, obj2.blank
            # Examen inicial
            if rect1.colliderect(rect2) is False:
                return False
        except AttributeError:
            return None
     
        # Conseguir el area superpuesta
        clip = rect1.clip(rect2)
     
        # Buscar donde esta la esquina superior izquierda de la superposicion en los dos rectangulos
        x1 = clip.left - rect1.left
        y1 = clip.top  - rect1.top
        x2 = clip.left - rect2.left
        y2 = clip.top  - rect2.top
     
        # Ciclo a traves del area de la superposicion de las mascaras
        for x in range(clip.width):
            for y in range(clip.height):
                # Devuelve True si ninguna de las dos imagenes tiene el pixel transparente
                if mask1[x1+x][y1+y] is not blank1 and mask2[x2+x][y2+y] is not blank2:
                    return True
     
        # Si no hay ninguna colision ni error
        return False

class PMalo():
    def __init__(self):
        '''self.imagenes = [[], [], [], []]
        n = 0
        for carpeta in ['right', 'left', 'up', 'down']:
            for numero in range(1, 5):
                self.imagen = pygame.image.load(PERS_MALO+carpeta+'/'+str(numero)+'.png')
                self.imagen.set_colorkey((0,0,0))
                self.imagen = pygame.transform.scale(self.imagen, (ANCHO/7, ANCHO/10))
                self.imagen = self.imagen.convert()
                self.imagenes[n].append(self.imagen)
            n += 1'''
        self.imagenes = []
        for numero in range(1, 32):
                self.imagen = pygame.image.load(PERS_MALO+'/'+str(numero)+'.png')
                self.imagen.set_colorkey((0,0,0))
                self.imagen = pygame.transform.scale(self.imagen, (ANCHO/20, ANCHO/20))
                self.imagen = self.imagen.convert()
                self.imagenes.append(self.imagen)
        self.rect = self.imagen.get_rect()
        self.rect = self.rect.inflate(-20,-20)
        self.rect.left = randint(0,ANCHO-int(ANCHO/20))
        self.rect.top = randint(int(ALTO/4),ALTO-int(ANCHO/20))
        #self.carpeta = 0
        self.velocidad = [VELOCIDADL,VELOCIDADL]
        self.num = 2
        self.cambio = 0
    def sube_nivel(self):
        self.velocidad[0] *= 2
        self.velocidad[1] *= 2
    def mover(self, vaca, contadorlobo, vidas, contador, sonido):
        global muerto
        
    # Detectar Bordes            
        if self.rect.right >= ANCHO:
            self.velocidad[0] = -self.velocidad[0]
            self.velocidad[1] = self.velocidad[1]
            #self.carpeta = 1
        elif self.rect.left < 0:
            self.velocidad[0] = -self.velocidad[0]
            self.velocidad[1] = self.velocidad[1]
            #self.carpeta = 0    
        if self.rect.top < ALTO/3.75:
            self.velocidad[1] = -self.velocidad[1]
            self.velocidad[0] = self.velocidad[0]
            #self.carpeta = 3
        elif self.rect.bottom > ALTO:
            self.velocidad[1] = -self.velocidad[1]
            self.velocidad[0] = self.velocidad[0]
            #self.carpeta = 2
        
        # Mover Objeto
            
        self.rect.left += self.velocidad[0]
        self.rect.top += self.velocidad[1]
        self.cambio += 1
        self.cambio %= 32
        if self.cambio == 0:
            self.num  += 1
            self.num = self.num % 31
        # Colision con Vaca
        if muerto == False and contador > 20:
            if self.rect.colliderect(vaca.rect):
                if sonido:
                    ch_sonidodamage = pygame.mixer.Channel(6)
                    ch_sonidodamage.play(pygame.mixer.Sound(sonidodamage))
                contadorlobo = 15
                vidas -= 1
                contador = 0
        contador += 1
        return contadorlobo,vidas, contador
    def dibujar(self, pantalla, muerto): 
        if muerto:
            self.rect.center = [0,0]
        else:        
            pantalla.blit(self.imagenes[self.num], self.rect)
        
# Objetos
        
class Objetivo():
    def __init__(self):
        self.imagen = pygame.image.load(PERS_PUNT)
        self.imagen = pygame.transform.scale(self.imagen, (ANCHO/15, ANCHO/15))
        self.imagen = self.imagen.convert()
        self.rect = self.imagen.get_rect()
        self.rect = self.rect.inflate(-30,-30)
    def mueve(self, tm, ALTO, ANCHO):
        # El objetivo aparecer cada 60 ciclos en un lugar    
        tm += 1
        # Pasado ese tiempo, cambiar de posicin
        if tm == 60:
            tm = 0
            self.rect.center = [randint(0,ANCHO-int(ANCHO/15)),randint(int(ALTO/3),ALTO-int(ANCHO/15))]
            stay = False       
            return tm, stay
        if tm < 60:
            stay = True
            return tm, stay
    def dibuja(self, muerto, pantalla):
        if muerto:
            self.rect.center = [0,0]
        else:
            pantalla.blit(self.imagen, self.rect)

class Velocidad():
    def __init__(self):
        self.imagen = pygame.image.load(PERS_VEL)
        self.imagen = pygame.transform.scale(self.imagen, (ANCHO/20, ANCHO/20))
        self.imagen = self.imagen.convert()
        self.imagen.set_colorkey((255,255,255))
        self.rect = self.imagen.get_rect()
        self.rect = self.rect.inflate(-15,-15)
        self.rect.center = [randint(0,ANCHO-int(ANCHO/20)),randint(int(ALTO/3),ALTO-int(ANCHO/20))]
    def mueve(self, tmr, ALTO, ANCHO):    
        tmr += 1
        if tmr == 59:
            self.rect.center = [randint(0,ANCHO-int(ANCHO/20)),randint(int(ALTO/3),ALTO-int(ANCHO/20))]
        if tmr == 100:
            tmr = 0
            self.rect.center = [0,0]
            stayr = False                   
        if tmr < 100 and tmr > 60:
            stayr = True
        else:
            stayr = False        
        return tmr, stayr
    def dibuja(self, muerto, pantalla):
        if muerto:
            self.rect.center = [0,0]
        else:
            pantalla.blit(self.imagen, self.rect)  

class Vida():
    def __init__(self):
        self.imagen = pygame.image.load(PERS_VIDA)
        self.imagen = pygame.transform.scale(self.imagen, (ANCHO/40, ANCHO/40))
        self.imagen = self.imagen.convert()
        self.imagen.set_colorkey((0,0,0))
        self.rect = self.imagen.get_rect()
        self.rect = self.rect.inflate(-1,-1)
        self.rect.center = [randint(0,ANCHO-int(ANCHO/15)),randint(int(ALTO/3),ALTO-int(ANCHO/15))]
    def mueve(self, tmv, ALTO, ANCHO, stayv, colis):   
        if colis:
            self.rect.center = [randint(0,ANCHO-int(ANCHO/15)),randint(int(ALTO/3),ALTO-int(ANCHO/15))]
            colis = False
        if tmv == 1:
            self.rect.center = [randint(0,ANCHO-int(ANCHO/15)),randint(int(ALTO/3),ALTO-int(ANCHO/15))]
            stayv = True
        if tmv > 60:
            stayv = False
            self.rect.center = [0,0]                
        return tmv, stayv, colis
    def colision(self, vidas, vaca, tmv, colis):
        collide = True
        if collide:
            if self.rect.colliderect(vaca.rect):
                if sonido:
                    ch_sonidovida = pygame.mixer.Channel(14)
                    ch_sonidovida.play(pygame.mixer.Sound(sonidovida))
                vidas += 1
                tmv = 61
                self.rect.center = [0,0]
                colis = True
        return vidas, tmv, colis
    def dibuja(self, muerto, pantalla):
        if muerto:
            self.rect.center = [0,0]
        else:
            pantalla.blit(self.imagen, self.rect)
            
            
            